// EZTCheckDlg.cpp : implementation file
// Copyright (C) 2000-2001 by Dosadi.  All Rights Reserved.
//

#include "stdafx.h"
#include "EZTCheck.h"
#include "EZTCheckDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEZTCheckDlg dialog

CEZTCheckDlg::CEZTCheckDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEZTCheckDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEZTCheckDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEZTCheckDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEZTCheckDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEZTCheckDlg, CDialog)
	//{{AFX_MSG_MAP(CEZTCheckDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEZTCheckDlg message handlers

BOOL CEZTCheckDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	int nVer = TWAIN_EasyVersion();
    CString msg;
    msg.Format(IDS_EZT_VER, nVer / 100, nVer % 100, TWAIN_BuildName());
    SetDlgItemText(IDC_EZT_VERSION, msg);
    msg.Format(TWAIN_IsAvailable() ? IDS_TWAIN_PRESENT : IDS_NO_TWAIN),
    SetDlgItemText(IDC_TWAIN_AVAIL, msg);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEZTCheckDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEZTCheckDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEZTCheckDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CEZTCheckDlg::Log(LPCTSTR pz)
{
    strcat(szLog, pz);
    SetDlgItemText(IDC_LOG, szLog);
    UpdateWindow();
} // Log


void CEZTCheckDlg::LogFailure(LPCTSTR pz)
{
    CString s;
    s.Format("\n  failure: %s", pz);
    Log(s);
    nFailures++;
}


void CEZTCheckDlg::OnStart() 
{
    szLog[0] = '\0';
    nTests = 0; nPassed = 0; bAbort = false;
    DoTest("TWAIN_SelfTest", &CEZTCheckDlg::SelfTest);
    DoTest("Flag Test", &CEZTCheckDlg::FlagTest);
    DoTest("Basic State Test", &CEZTCheckDlg::BasicStateTest);
    DoTest("Source List Test", &CEZTCheckDlg::SourceListTest);
    Log("\n");
    CString s;
    s.Format("Testing Results: %d out of %d tests passed.\n", nPassed, nTests);
    Log(s);
    if (nPassed == nTests) {
        s.Format("* Complete Success *");
    } else if (nPassed != 0) {
        s.Format("* Partial Success *");
    } else {
        s.Format("* Total Failure *");
    }
    Log(s);
}

void CEZTCheckDlg::DoTest(LPCTSTR pzName, TESTFN fn)
{
    nTests++;
    Log(pzName);
    Log("... ");
    if (bAbort) {
        Log("aborted.");
    } else {
        nFailures = 0;
        (this->*fn)();
        if (nFailures == 0) {
            // success
            Log("passed.");
            nPassed++;
        } else {
            // Failed
            CString msg;
            msg.Format("\n-- %s failed!", pzName);
            Log(msg);
#if 0
            msg.Format("%s failed.\nContinue testing?", pzName);
            if (IDNO == AfxMessageBox(msg, MB_ICONEXCLAMATION | MB_YESNO)) {
                bAbort = true;
            }
#endif
        }
    }
    Log("\n");
}


void CEZTCheckDlg::SelfTest(void)
{
    int n = TWAIN_SelfTest(0);
    if (n != 0) {
        LogFailure("TWAIN_SelfTest");
    }
}

void CEZTCheckDlg::FlagTest(void)
{
    int n;

    // Check TWAIN_IsAvailable()
    if (TWAIN_IsAvailable() != TRUE) {
        LogFailure("TWAIN_IsAvailable() != TRUE");
    } else {
        DWORD t0 = GetTickCount(), dt = 0;
        long cc = 0;
        while (TWAIN_IsAvailable()) {
            cc++;
            dt = (DWORD)(GetTickCount() - t0);
            if (dt >= 2) {
                break;
            }
        }
        if ((cc / dt) < 10) {
            LogFailure("TWAIN_IsAvailable too slow!");
        }
    }

    // Check TWAIN_IsJpegAvailable
    if (TWAIN_IsJpegAvailable() != TRUE) {
        LogFailure("TWAIN_IsJpegAvailable() != TRUE");
    } else {
        int nFF = TWAIN_GetSaveFormat();
        if (nFF != TWFF_BMP) {
            LogFailure("initial Save Format not TWFF_BMP");
        }
        if (TWAIN_SetSaveFormat(TWFF_BMP) != 1) {
            LogFailure("TWAIN_SetSaveFormat(TWFF_BMP) != 1");
        } else if (TWAIN_GetSaveFormat() != TWFF_BMP) {
            LogFailure("Set/Get SaveFormat(TWFF_BMP)");
        }
        if (TWAIN_SetSaveFormat(TWFF_JFIF) != 1) {
            LogFailure("TWAIN_SetSaveFormat(TWFF_JFIF) != 1");
        } else if (TWAIN_GetSaveFormat() != TWFF_JFIF) {
            LogFailure("Set/Get SaveFormat(TWFF_JFIF)");
        }
        if (TWAIN_SetSaveFormat(0) != 0) {
            LogFailure("TWAIN_SetSaveFormat(0) != 0");
        }
        if (TWAIN_SetSaveFormat(1) != 0) {
            LogFailure("TWAIN_SetSaveFormat(1) != 0");
        }
        if (TWAIN_SetSaveFormat(3) != 0) {
            LogFailure("TWAIN_SetSaveFormat(3) != 0");
        }
        
        if (TWAIN_GetJpegQuality() != 75) {
            LogFailure("initial TWAIN_GetJpegQuality() != 75");
        }
        TWAIN_SetJpegQuality(1);
        if (TWAIN_GetJpegQuality() != 1) {
            LogFailure("Set /Get JpegQuality(1)");
        }
        TWAIN_SetJpegQuality(50);
        if (TWAIN_GetJpegQuality() != 50) {
            LogFailure("Set /Get JpegQuality(50)");
        }
        TWAIN_SetJpegQuality(100);
        if (TWAIN_GetJpegQuality() != 100) {
            LogFailure("Set /Get JpegQuality(100)");
        }
        TWAIN_SetJpegQuality(75);
        if (TWAIN_GetJpegQuality() != 75) {
            LogFailure("Set /Get JpegQuality(75)");
        }
    }


    // Check MultiTransfer
    if (TWAIN_GetMultiTransfer() != 0) {
        LogFailure("initial GetMultiTransfer() != 0");
    }
    TWAIN_SetMultiTransfer(1);
    if (TWAIN_GetMultiTransfer() != 1) {
        LogFailure("Set/GetMultiTransfer(1)");
    }
    TWAIN_SetMultiTransfer(0);
    if (TWAIN_GetMultiTransfer() != 0) {
        LogFailure("Set/GetMultiTransfer(0)");
    }

    // Check HideUI
    if (TWAIN_GetHideUI() != 0) {
        LogFailure("initial GetHideUI() != 0");
    }
    TWAIN_SetHideUI(1);
    if (TWAIN_GetHideUI() != 1) {
        LogFailure("Set/GetHideUI(1)");
    }
    TWAIN_SetHideUI(0);
    if (TWAIN_GetHideUI() != 0) {
        LogFailure("Set/GetHideUI(0)");
    }

    // Check DisableParent
    if (TWAIN_GetDisableParent() != 1) {
        LogFailure("initial GetDisableParent() != 1");
    }
    TWAIN_DisableParent(0);
    if (TWAIN_GetDisableParent() != 0) {
        LogFailure("Set/GetDisableParent(0)");
    }
    TWAIN_DisableParent(1);
    if (TWAIN_GetDisableParent() != 1) {
        LogFailure("Set/GetDisableParent(1)");
    }

    // Check TWAIN_SuppressErrorMessages
    n = 0;
    int nPrev = TWAIN_SuppressErrorMessages(1);
    if (nPrev != FALSE && nPrev != TRUE) {
        n++;
    }
    if (TWAIN_SuppressErrorMessages(0) != TRUE) {
        n++;
    }
    if (TWAIN_SuppressErrorMessages(55) != FALSE) {
        n++;
    }
    if (TWAIN_SuppressErrorMessages(nPrev) != TRUE) {
        n++;
    }
    if (n != 0) {
        LogFailure("TWAIN_SuppressErrorMessages");
    }
}


void CEZTCheckDlg::BasicStateTest(void)
{
    TWAIN_UnloadSourceManager();
    if (TWAIN_State() != TWAIN_PRESESSION) {
        LogFailure("TWAIN_State() != TWAIN_PRESESSION");
        return;
    }
    if (TWAIN_LoadSourceManager() != 1 ||
        TWAIN_State() != TWAIN_SM_LOADED) {
        LogFailure("TWAIN_LoadSourceManager");
        return;
    }
    if (TWAIN_OpenSourceManager(*this) != 1 ||
        TWAIN_State() != TWAIN_SM_OPEN) {
        LogFailure("TWAIN_OpenSourceManager");
        return;
    }
    if (TWAIN_CloseSourceManager(*this) != 1 ||
        TWAIN_State() != TWAIN_SM_LOADED) {
        LogFailure("TWAIN_CloseSourceManager");
        return;
    }
    if (TWAIN_UnloadSourceManager() != 1 ||
        TWAIN_State() != TWAIN_PRESESSION) {
        LogFailure("TWAIN_UnloadSourceManager");
        return;
    }
}

void CEZTCheckDlg::SourceListTest(void)
{
    if (TWAIN_GetSourceList() != 1) {
        LogFailure("TWAIN_GetSourceList() != 1");
        return;
    }
    TCHAR szBeforeDir[_MAX_PATH], szAfterDir[_MAX_PATH];
    GetCurrentDirectory(_MAX_PATH+1, szBeforeDir);
    CHAR szSource[256];
    for (int i = 0; i < 99; i++) {
        if (TWAIN_GetNextSourceName(szSource) != 1) {
            break;
        }
    }
    TWAIN_GetDefaultSourceName(szSource);
    GetCurrentDirectory(_MAX_PATH+1, szAfterDir);
    if (strcmp(szBeforeDir, szAfterDir) != 0) {
        LogFailure("strcmp(szBeforeDir, szAfterDir) != 0");
        return;
    }
}
